//---------------------------------------------------------------------------
// TListViewExt 1.0
// By Roberto Fiume - BRINDISI ITALY -
// e-mail froberto@hotmail.com
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ListViewExt.h"
//---------------------------------------------------------------------------
static inline TListViewExt *ValidCtrCheck()
{
	return new TListViewExt(NULL);
}
//---------------------------------------------------------------------------
__fastcall TListViewExt::TListViewExt(TComponent* Owner): TListView(Owner)
{
	 m_GridLines = m_HotTrack = m_RowSelect = false;
}

void TListViewExt::ResetExStyles (void)
{
	DWORD Styles = 0;
	if (m_GridLines) Styles = Styles | LVS_EX_GRIDLINES;
	if (m_HotTrack)  Styles = Styles | LVS_EX_TRACKSELECT;
	if (m_RowSelect) Styles = Styles | LVS_EX_FULLROWSELECT;
	ListView_SetExtendedListViewStyle(Handle, Styles);
}

bool TListViewExt::ListView_SetExtendedListViewStyle (HWND hwndLV,DWORD dw)
{
	 return bool(SendMessage(hwndLV, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, dw));
}

void __fastcall TListViewExt::SetGridLines(const bool value)
{
	if (m_GridLines != value)
	{
		m_GridLines = value;
		ResetExStyles();
	}
}

void __fastcall TListViewExt::SetHotTrack(const bool value)
{
	if (m_HotTrack != value)
	{
		m_HotTrack = value;
		ResetExStyles();
	}
}

void __fastcall TListViewExt::SetRowSelect(const bool value)
{
	if (m_RowSelect != value)
	{
		m_RowSelect = value;
		ResetExStyles();
	}
}
//---------------------------------------------------------------------------
namespace Listviewext
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TListViewExt)};
		RegisterComponents("Tools", classes, 0);
	}
}
//---------------------------------------------------------------------------
